<script lang="ts">
  export type OptionsItem = { label: string; value: string; disabled?: boolean };
  export interface OnChangeHookParams {
    options: Ref<OptionsItem[]>;
  }
</script>

<script lang="ts" setup>
  import { ref, watchEffect, computed, unref, watch, Ref } from 'vue';
  import { Select } from 'ant-design-vue';
  import { isFunction } from '/@/utils/is';
  import { useRuleFormItem } from '/@/hooks/component/useFormItem';
  import { useAttrs } from '/@/hooks/core/useAttrs';
  import { get, omit } from 'lodash-es';
  import { LoadingOutlined } from '@ant-design/icons-vue';
  import { useI18n } from '/@/hooks/web/useI18n';

  const emit = defineEmits(['options-change', 'change']);
  const props = withDefaults(
    defineProps<{
      value?: Recordable | number | string;
      numberToString?: boolean;
      api?: (arg?: Recordable) => Promise<OptionsItem[]>;
      searchApi?: (arg?: Recordable) => Promise<OptionsItem[]>;
      params?: Recordable;
      resultField?: string;
      labelField?: string;
      valueField?: string;
      immediate?: boolean;
      queryEmptyDataAgin?: boolean;
      onChangeHook?: ({ options }: OnChangeHookParams) => void;
      dropdownVisibleChangeHook?: ({ options }: OnChangeHookParams) => void;
    }>(),
    {
      resultField: '',
      labelField: 'label',
      valueField: 'value',
      immediate: true,
      queryEmptyDataAgin: true,
    }
  );
  const options = ref<OptionsItem[]>([]);
  const loading = ref(false);
  const isFirstLoad = ref(true);
  const emitData = ref<any[]>([]);
  const attrs = useAttrs();
  const { t } = useI18n();

  // Embedded in the form, just use the hook binding to perform form verification
  const [state] = useRuleFormItem(props, 'value', 'change', emitData);

  const getOptions = computed(() => {
    const { labelField, valueField = 'value', numberToString } = props;
    return unref(options).reduce((prev, next: Recordable) => {
      if (next) {
        const value = next[valueField];
        prev.push({
          label: next[labelField],
          value: numberToString ? `${value}` : value,
          ...omit(next, [labelField, valueField]),
        });
      }
      return prev;
    }, [] as OptionsItem[]);
  });

  watchEffect(() => {
    props.immediate && fetch();
  });

  watch(
    () => props.params,
    () => {
      !unref(isFirstLoad) && fetch();
    },
    { deep: true }
  );

  async function fetch() {
    const api = props.api;
    if (!api || !isFunction(api)) return;
    options.value = [];
    try {
      loading.value = true;
      const res = await api(props.params);
      if (Array.isArray(res)) {
        options.value = res;
        emitChange();
        return;
      }
      if (props.resultField) {
        options.value = get(res, props.resultField) || [];
      }
      emitChange();
    } catch (error) {
      console.warn(error);
    } finally {
      loading.value = false;
    }
  }

  async function handleFetch() {
    const { immediate, dropdownVisibleChangeHook } = props;
    if (!immediate && unref(isFirstLoad)) {
      await fetch();
      isFirstLoad.value = false;
    }
    if (dropdownVisibleChangeHook && isFunction(dropdownVisibleChangeHook)) {
      dropdownVisibleChangeHook({ options });
    }
  }

  function emitChange() {
    emit('options-change', unref(getOptions));
  }

  function handleChange(value: string, ...args) {
    emitData.value = args;
    if (!value && props.queryEmptyDataAgin) handleSearch();
    const { onChangeHook } = props;
    if (!onChangeHook && !isFunction(onChangeHook)) return;
    onChangeHook({ options });
  }

  async function handleSearch(params?: string) {
    let { searchApi, api } = props;
    if (!searchApi || !isFunction(searchApi)) {
      if (!api || !isFunction(api)) return;
      searchApi = api;
    }
    options.value = [];
    try {
      loading.value = true;
      const res = await searchApi({ ...props.params, text: params });
      if (Array.isArray(res)) {
        options.value = res;
        emitChange();
        return;
      }
      if (props.resultField) {
        options.value = get(res, props.resultField) || [];
      }
      emitChange();
    } catch (error) {
      console.warn(error);
    } finally {
      loading.value = false;
    }
  }
</script>

<template>
  <Select
    @dropdownVisibleChange="handleFetch"
    v-bind="attrs"
    show-search
    @change="handleChange"
    :options="getOptions"
    @search="handleSearch"
    v-model:value="state"
  >
    <template #[item]="data" v-for="item in Object.keys($slots)">
      <slot :name="item" v-bind="data || {}"></slot>
    </template>
    <template #suffixIcon v-if="loading">
      <LoadingOutlined spin />
    </template>
    <template #notFoundContent v-if="loading">
      <span>
        <LoadingOutlined spin class="mr-1" />
        {{ t('component.form.apiSelectNotFound') }}
      </span>
    </template>
  </Select>
</template>
